/*
 * libunsigned - Unsigned MSSTYLES patching/support library for Win32/Win64
 * Copyright (C) 2007 Rafael Rivera Jr., http://www.anti-tgtsoft.com
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 */

#pragma once
#include <windows.h>

#define LIBUNSIGNED_H
#define WIN32_LEAN_AND_MEAN

// amount of opcodes to scan through
// before giving up
#define SCAN_THRESHOLD 75

// handful of opcodes for fuzzy x86/64
// disassembler
#define X64_EXTENSION		0x48
#define OPCODE_SUB_UNSIGNED 0x81
#define OPCODE_SUB_SIGNED	0x83
#define OPCODE_LEA			0x8d
#define OPCODE_CALL			0xe8
#define OPCODE_JMP			0xe9
#define OPCODE_MOV			0xeb

// nothing-special types
#ifndef SWORD
	typedef signed short SWORD;
#endif

#ifndef SDWORD
	typedef signed long  SDWORD;
#endif

// generic helper functions
VOID elevatePrivs();
VOID patchProcess( LONGLONG, DWORD );
VOID writePatchBytes( HANDLE, INT64 );
VOID launchCplApplet( DWORD*, HANDLE* );

// fuzzy disassembler functions + patches
// (platform specific)

#ifdef WIN64
	#define findTarget AMD64fuzzyTargetFinder
	LONGLONG AMD64fuzzyTargetFinder();
	static const DWORD PATCH =	0xC3C03148;
#else
	#define findTarget X86fuzzyTargetFinder
	LONGLONG X86fuzzyTargetFinder();
	static const LONGLONG PATCH =	0x0008C2C9C68BF633;
#endif  

// Morgan W. is my friend.