/*
 * libunsigned - Unsigned MSSTYLES patching/support library for Win32/Win64
 * Copyright (C) 2007 Rafael Rivera Jr., http://www.anti-tgtsoft.com
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 *  Rafael Rivera Jr.
 *  rafael(@)fromvistatoxp.com
 *
 */

#include "libunsigned.h"

// summary:		Launch the display properties control panel applet

// description:	Do you really need additional verbiage?

// returns:		Nothing

VOID launchCplApplet( DWORD* dwPid, HANDLE* hProcess )
{
	// forced to ANSI because CreateProcess is one of those
	// bastard APIs that reacts slightly different in
	// UNICODE mode...

	STARTUPINFOA si;
	ZeroMemory(&si, sizeof(si));

	si.cb = sizeof(STARTUPINFOA);
	si.wShowWindow = SW_HIDE;

	PROCESS_INFORMATION pi;
	ZeroMemory( &pi, sizeof(PROCESS_INFORMATION) );

	LPSTR szCmd = "rundll32.exe shell32.dll,Control_RunDLL Desk.cpl,@0, -1";
	CreateProcessA( NULL, szCmd, NULL, NULL, FALSE, 0x00, NULL, NULL, &si, &pi );

	*dwPid = pi.dwProcessId;
	*hProcess = pi.hProcess;
}

// summary:		Patch an existing (specified) process

// description:	Attaches to an existing (specified) process
//				and applies	hard-coded set of patch bytes on
//				specified address

// parameters:	uxBaseAddress - Address to apply patch to
//				dwPid - Process ID of running process to patch

// returns:		Nothing

VOID patchProcess( LONGLONG uxBaseAddress, DWORD dwPid )
{

	// peek into process with vm flags
	HANDLE hProcess = 0x00;
	hProcess = OpenProcess(
		PROCESS_VM_OPERATION | PROCESS_VM_READ | PROCESS_VM_WRITE,
		FALSE,
		dwPid );

	writePatchBytes( hProcess, uxBaseAddress );
}

// summary:		Patch a piece of memory, attached to a process

// description:	Unprotects memory owned by specified process,
//				writes patch bytes to specified location, and
//				re-protects memory (now private local copy)

// parameters:	hProcess - Handle to process with VM_OPERATION,
//				PROCESS_VM_READ, and PROCESS_VM_WRITE access
//				flags

//				targetAddress - Address to apply patch to

// returns:		Nothing

VOID writePatchBytes( HANDLE hProcess, INT64 targetAddress )
{
	VirtualProtectEx( hProcess, (LPVOID)targetAddress, sizeof(PATCH), PAGE_EXECUTE_READWRITE, NULL );
	WriteProcessMemory( hProcess, (LPVOID)targetAddress, &PATCH, sizeof(PATCH), NULL );
	VirtualProtectEx( hProcess, (LPVOID)targetAddress, sizeof(PATCH), PAGE_EXECUTE_READ, NULL );

	CloseHandle(hProcess);
}

// summary:		Elevate privileges

// description:	Enable the process to access and modify memory
//				otherwise protected from access by granting
//				ourself SeDebugPrivlege (requires admin. privs.)

// parameters:	Nothing

// returns:		Nothing

VOID elevatePrivs()
{
	HANDLE	hToken;
	TOKEN_PRIVILEGES tp, oldtp;

	DWORD	dwSize = 0x00;
	LUID	luid;

	OpenProcessToken( GetCurrentProcess(), TOKEN_ADJUST_PRIVILEGES | TOKEN_QUERY, &hToken );
	LookupPrivilegeValue( NULL, SE_DEBUG_NAME, &luid );

	ZeroMemory( &tp, sizeof(tp) );

	tp.PrivilegeCount = 1;
	tp.Privileges[0].Luid = luid;
	tp.Privileges[0].Attributes = SE_PRIVILEGE_ENABLED;

	AdjustTokenPrivileges( hToken, FALSE, &tp, sizeof(TOKEN_PRIVILEGES), &oldtp, &dwSize );
	CloseHandle( hToken );
}

// Morgan W. is my friend.