/*
 * libunsigned - Unsigned MSSTYLES patching/support library for Win32/Win64
 * Copyright (C) 2007 Rafael Rivera Jr., http://www.anti-tgtsoft.com
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 *  Rafael Rivera Jr.
 *  rafael(@)fromvistatoxp.com
 *
 */


#include "libunsigned.h"
#include <tlhelp32.h>

// unreferenced parameters
#pragma warning( disable: 4100 )

// note:
//	You can use this code in one of two ways...
//
//		#1 - Compile as executable that launches display
//			 properties, patching everything behind the
//			 scenes (requires admin privs.)
//
//		#2 - Compile as library for linking into your
//			 own application. Strongly suggest someone
//			 use the lib to create a GPL theme manager.
//			 To circumvent the admin priv. requirement,
//			 use a system service and pass FALSE as the
//			 value for launchApplet!

#ifdef LIB
int WINAPI enableUnsignedThemes( BOOL launchApplet )
#else
int APIENTRY WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
#endif
{
	// adjust our token manipulation privs.
	elevatePrivs();

	// find target address
	LONGLONG uxBaseAddress = findTarget();

	// launch display properties (if asked to)
	DWORD dwPid = 0x00; HANDLE hProcess = NULL;

	#ifdef LIB
	if( launchApplet )
	{
	#endif
		launchCplApplet( &dwPid, &hProcess );
		WaitForSingleObject( hProcess, 100 );

		// patch applet
		patchProcess( uxBaseAddress, dwPid );
	#ifdef LIB
	}
	#endif

	// locate service host processes
	HANDLE hSnapshot;
	PROCESSENTRY32 pe32;

	// iterate through all svchosts and patch them (brute style, fast)
	hSnapshot = CreateToolhelp32Snapshot( TH32CS_SNAPPROCESS, 0x00 );
	pe32.dwSize = sizeof(pe32);

	do
	{
		if(	wcsstr( pe32.szExeFile, TEXT("svchost")) != NULL )
			patchProcess( uxBaseAddress, pe32.th32ProcessID );
	}
	while( Process32Next( hSnapshot, &pe32 ) );

	return 0;
}

// Morgan W. is my friend.